#include <stdio.h>
#include <ctype.h>
#include "/home/cordyn/mk3S/EWmap.h"

/* short BCmap[PA][BLONGS]; */ /*Position angle goes from north to south to
				  north, 0 to 359 degrees. */
			       /* BCmap is arranged so longitude "goes" 
				  fastest. */
/* short Bmap[MLATS][BLONGS];*/ /*East and West maps go from north to south */
			       /* Bmap is arranged so longitude "goes" 
				  fastest. */
/* For both Bmap and BCmap, (imap and cmap) 
       longitude goes from 0 to 360 degrees, 
       with 0 degrees on the left and 360 degrees on the right.
       Time is reversed, so that the earliest day is on the right,
       and the latest day is on the left.
   In idl, cmap can be displayed with: a=intary(360,360)
					tvscl,a,order=1
   In idl, imap can be displayed with: a=intary(360,181)
					tvscl,a,order=1
*/

/* float pB[DAYS][LATS]  ; */  /* East file goes from north to south
				  West file goes from south to north */
                               /* Time goes in the forward direction. */
			       /* pB is arranged so latitude "goes" 
				  fastest. */
extern int offset ;

double  El_beg = 2445061 , El_lconst = 2445335 , El_last = 2446796 ;
float   El_corr = 75 , El_slope = 0.051335 ;
float   El_fix , get_El_fix() ;
/* pB units are 10^-10 B/Bsun for input data and for Bmap and imap */
/* pB units are 10^-10 B/Bsun for input data and for BCmap and cmap */
/* pB units for the EWfile are are 10^-8 B/Bsun */
    

fillEmap(bigmap,sy,flong,f_juld) 
    short *bigmap , *sy ;
    float flong ; double f_juld ;
{
    int ilat , ilong ;
    short *big , *stemp  ;  

    El_fix = get_El_fix(f_juld) ; /* El Chicon fix. */

    ilong = (int) flong ;

    stemp = sy ;
    big = bigmap ;
    for( ilat = 0 ; ilat < MLATS ;  ilat++ ) { /* Fill Bmap North to South */
	*(big+ilat*BLONGS+ilong+offset) = *stemp + (short)El_fix ;
	stemp++ ;
    }

}
fillWmap(bigmap,sy,flong,f_juld) 
    short *bigmap , *sy ;
    float flong ; double f_juld ;
{
    int ilat , ilong ;
    short *stemp , *big ;

    El_fix = get_El_fix(f_juld) ; /* El Chicon fix. */

    ilong = (int) flong ;

    stemp = sy ;
    big = bigmap  ;
    *(big+0*BLONGS+ilong+offset) = *stemp ;

    stemp = sy ;	 stemp += 359 ;

    for( ilat = 1 ; ilat < MLATS ;  ilat++ ) { /* Fill Bmap North to South */
	*(big+ilat*BLONGS+ilong+offset) = *stemp + (short) El_fix ;
	stemp-- ;  /* Reverse order. */
    }
}

fillCmap(bigmap,sy,flong,f_juld) 
    short *bigmap , *sy ;
    float flong ; double f_juld ;
{
    int pa , ilong ;
    short *stemp , *big  ;  

    El_fix = get_El_fix(f_juld) ; /* El Chicon fix. */
    ilong = (int) flong ;

    stemp = sy ;
    big = bigmap ;
    for( pa = 0 ; pa < PA ;  pa++ ) { /* Fill BCmap North to South to North */
	*(big+pa*BLONGS+ilong+offset) = *stemp + (short)El_fix ;
	stemp++ ;
    }
}


fillEfile(fpB,sy,iday) float *fpB ;  short *sy ;  int iday ; {
    int  ll , kk ;
    short *stemp  ;  
    float  avg5 ;  

    /* pB data for east file goes from north to south. */
    stemp = sy ;

    ll = 0 ; {
	for( kk=0, avg5=0 ; kk<3 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	avg5 /= 300.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }
    for ( ll= 1 ; ll< 36 ; ll++ ) {
	for( kk=0, avg5=0 ; kk<5 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	avg5 /= 500.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }
    ll = 36 ; {
	for( kk=0, avg5=0 ; kk<3 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	avg5 /= 300.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }

}
fillWfile(fpB,sy,iday) float *fpB ; short *sy ;  int iday ; {
    int ll , kk ;
    short *stemp  ;  
    float avg5 ;  

    /* pB data for west file goes from south to north. */

    stemp = sy ;	 stemp += 180 ;


    ll = 0 ; {
	for( kk=0, avg5=0 ; kk<3 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	avg5 /= 300.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }
    for ( ll= 1 ; ll< 36 ; ll++ ) {
	for( kk=0, avg5=0 ; kk<5 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	avg5 /= 500.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }
    ll = 36 ; {
	for( kk=0, avg5=0 ; kk<2 ;  kk++ ) { avg5 += (float)*stemp ; stemp++ ; }
	stemp = sy ;                         avg5 += (float)*stemp ;
	avg5 /= 300.0 ;  /* Avg and convert to 10^-8 B/Bsun */
	*(fpB+iday*LATS+ll) = avg5 ;
    }
}


float get_El_fix(f_juld) double f_juld ; {
    
    /* El Chicon fix in terms of 10^-10 B/Bsun */
    if ( f_juld >= El_beg && f_juld <= El_last ) {
	if ( f_juld <= El_lconst ) 
			return ( El_corr ) ;
	else            return ( El_corr - El_slope*(f_juld-El_lconst) ) ;
    }
    else {
		        return ( 0 ) ;
    }
}
