/* fill_ims_availv2.c
 *------------------------------------------------------------------------------
 * Add image information to ASCII array for synopic map tailer.
 *
 * fill_ims_avail ()
 *------------------------------------------------------------------------------
 * Author:  Alice Lecinski   HAO/NCAR    3 Nov 1997   [fill_ims_avail.c]
 * Updates: Andrew Stanger   HAO/NCAR
 * 14 Nov 2002: Cosmetic changes.  Add comments.
 *------------------------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>
#include "EWmap4.h"
#include "/home/stanger/fits/lib/mk4v2/mk4v2.h"
#include "/home/stanger/fits/lib/mk4v2/mk4headv2.h"

extern char ims_avail [10000] ;
extern int  num_ims_avail, num_lines ;
extern int  useyn ;

/*--------------------------------------------------------------------------- */

void
fill_ims_avail (syfilhd, elong, wlong, clong, juld) 

struct mk4_header *syfilhd ;
float elong ;			/* East Limb Longitude. */
float wlong ;			/* West Limb Longitude. */
float clong ;			/* Central Meridian Longitude. */
double juld ;			/* Julian date. */
{
    char   aline [80], *q, *p;
    int    mon, day, yr, doy ;
    extern int   jdate (), iday ()  ;

    q = ims_avail ;  
    p = aline ;

    jdate ( (long) juld, &mon, &day, &yr ) ;  
    doy = iday ( mon, day, yr ) ;

    if ( useyn )
	sprintf (aline, 
		"%s  Doy %3d  %.8s    E %7.1f  W %7.1f  CM %7.1f      ? y\n", 
		prday (syfilhd->Image.Juld), doy, prtime (syfilhd->Image.Time), 
		elong, wlong, clong ) ;
    else 
	sprintf (aline, 
		"%s  Doy %3d  %.8s    E %7.1f  W %7.1f  CM %7.1f      ? n\n", 
		prday (syfilhd->Image.Juld), doy, prtime (syfilhd->Image.Time), 
		elong, wlong, clong ) ;

    q += strlen (q) ;
    for ( ; *p ; p++, q++ ) *q = *p ;
    *q = '\0';

    num_ims_avail++ ;
    num_lines++ ;
}

/*--------------------------------------------------------------------------- */
