/* fill_ims_avail.c
 *------------------------------------------------------------------------------
 * Create the ASCII footer information.
 *------------------------------------------------------------------------------
 * Author:  Alice Lecinski   HAO/NCAR    5 Mar 1998
 * Updates: Andrew Stanger   HAO/NCAR   14 Mar 2002
 * 14 Mar 2002: adapt for Mk4.
 *------------------------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>
#include "/home/cordyn/mk4/syn/EWmap4.h"
#include "/home/cordyn/mk4/src/mk4v2.h"
#include "/home/cordyn/mk4/src/mk4headv2.h"

extern char ims_avail [10000] ;
extern int  num_ims_avail, num_lines ;
extern int  useyn ;

/* -------------------------------------------------------------------------- */

void fill_ims_avail (syfilhd, elong, wlong, clong, juld) 

/*    register SFH syfilhd;   */

    struct mk4_header *syfilhd ;
    float elong, wlong, clong ;
    double juld ;
{
    char   aline [80], *q, *p;
    int    mon, day, yr, doy ;
    extern int   jdate (), iday ()  ;

    q = ims_avail ;  
    p = aline ;

    jdate ( (long) juld, &mon, &day, &yr ) ;  
    doy = iday ( mon, day, yr ) ;

    if ( useyn )
	sprintf (aline, 
	"%s  Doy %3d  %.8s    E %7.1f  W %7.1f  CM %7.1f      ? y\n", 
         prday (syfilhd->Image.Juld), doy, prtime (syfilhd->Image.Time), 
	elong, wlong, clong ) ;
    else 
	sprintf (aline, 
	"%s  Doy %3d  %.8s    E %7.1f  W %7.1f  CM %7.1f      ? n\n", 
         prday (syfilhd->Image.Juld), doy, prtime (syfilhd->Image.Time), 
	elong, wlong, clong ) ;

    q += strlen (q) ;
    for ( ; *p ; p++, q++ ) *q = *p ;
    *q = '\0';

    num_ims_avail++ ;
    num_lines++ ;
}

/* -------------------------------------------------------------------------- */

