/* ck_get.c
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * Author: Alice Lecinski       HAO/NCAR
 * Updates: Andrew L. Stanger   HAO/NCAR   17 Oct 2002
 * 17 Oct 2002: Adapt for Mk4.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

#include "/home/cordyn/mk4/syn/EWmap4.h"

extern long    iFbegEj , iFendEj , iFbegWj , iFendWj ;
extern double  begEj , endEj , begWj , endWj , begCj , endCj ;
extern double  slopeE , slopeW , slopeC ;

/* -------------------------------------------------------------------------- */

void
ck_get_day (juld, time, eday, wday, fjuld) 

    unsigned short juld;
    unsigned time;
    int *eday ,  *wday ; 
    double *fjuld ;
{
    int itmp;  double jdt ;  long ijdt ;

    itmp = time ;

    *fjuld = (double) (juld) + 2415021 + ((double) itmp ) / ONEDAY;
    jdt = *fjuld ;
    ijdt = (long) jdt ;

    if ( (ijdt >= iFbegEj) && (ijdt <= iFendEj) )
	{
	*eday = (int) (ijdt - iFbegEj ) ;
        }
    else      *eday = -9999 ;

    if ( ijdt >= iFbegWj && ijdt <= iFendWj )
	{
	*wday = (int) (ijdt - iFbegWj ) ;
        }
    else      *wday = -9999 ;

/*
 *  fprintf(stderr, " eday %d ,  wday %d ,  juld %.1lf \n", *eday,  *wday,  jdt);
 */
}

/* -------------------------------------------------------------------------- */

void
ck_get_long (juld, time, elong, wlong, clong, fjuld) 

    unsigned short juld;
    unsigned time;
    float *elong ,  *wlong ,  *clong ; 
    double *fjuld ;
{
    int itmp;  double jdt ;

    itmp = time ;

    *fjuld = (double) (juld) + 2415021 + ((double) itmp ) / ONEDAY;
    jdt = *fjuld ;

    if ( jdt > begEj-OVLAP && jdt < endEj+OVLAP )
	{
	*elong =  (360.0 - (jdt - begEj)*slopeE  + 0.0  ) ;
        }
    else      *elong = -9999 ;

    if ( jdt > begWj-OVLAP && jdt < endWj+OVLAP )
	{
	*wlong = (360.0 - (jdt - begWj)*slopeW  +  0.0  ) ;
        }
    else      *wlong = -9999 ;

    if ( jdt > begCj-OVLAP && jdt < endCj+OVLAP )
	{
	*clong =  (360.0 - (jdt - begCj)*slopeC  + 0.0  ) ;
        }
    else      *clong = -9999 ;
}

/* -------------------------------------------------------------------------- */
