/* mapnm.c
 *------------------------------------------------------------------------------
 * do_EWmapnm
 * do_mapnm
 *------------------------------------------------------------------------------
 * Author:  Alice Lecinski   HAO/NCAR    6 Feb 1997   mapnm.c
 * Updates: Andrew Stanger   HAO/NCAR   14 Mar 2002
 * 14 Mar 2002: cosmetic changes only.
 *  6 Nov 2002: Revise output file name.
 *------------------------------------------------------------------------------
 */

#include <stdio.h>
#include <ctype.h>

extern  int  local ;
extern  int  east , west , CMmap ;
extern  char EWpath [] , EWmapnm [] ;

/* -------------------------------------------------------------------------- */

do_EWmapnm (Crot, height)

register int Crot ;
float height ;
{
    register char *p ;

    /*  0123456789.123456789.123456789.123456789.123456789.123
     * /slug/cordyn/d/mk3S/DATA/EW_files/height_.__/MK____.E 
     */

    p = EWmapnm ;
    if (east)
	{ 
/*
 *	sprintf (p, "/slug/cordyn/d/mk3S/DATA/EW_files/height%.2f/MK%4d.E",
 *	         height, Crot); 
 */
	sprintf (p, "/puu/d/cordyn/d/mk4/syn/height%.2f/MK%4d.E",
	         height, Crot); 
	p += 53;
	}
    if (west)
	{ 
/*
 *	sprintf (p, "/slug/cordyn/d/mk3S/DATA/EW_files/height%.2f/MK%4d.W",
 *	         height, Crot); 
 */
	sprintf (p, "/puu/d/cordyn/mk4/syn/height%.2f/MK%4d.W",
	         height, Crot); 
	p += 53;
	}
    *p = '\0';

    p = EWpath ;
    sprintf (p,"/slug/cordyn/d/mk3S/DATA/EW_files/height%.2f",height); 
    p += 44;
    *p = '\0';

    return (0) ;
}

/* -------------------------------------------------------------------------- */

extern  char mapnm [] ;

do_mapnm (Crot, height)

register int Crot ;
float height ;
{
    char *p = mapnm , *q ;
    char e_w_cm [2] ;

    /*  0123456789.123456789.123456789.123456789.1234
     *  /slug/cordyn/d/mk3S/DATA/Synopmaps/____e_.__ 
     */

    q = e_w_cm ;
    if (east)     *q++ = 'e' ;
    if (west)     *q++ = 'w' ;
    if (CMmap)    *q++ = 'c' ;
    *q = '\0' ;

    if (!local)
	{
	sprintf (p, "/puu/d/cordyn/mk4/syn/mk4.%1s%4d.r%03d",
	         e_w_cm, Crot, (int) (height * 100)); 
	p += 36;
	}
    else
	{
	sprintf (p, "mk4.%1s%4d.r%03d",
	         e_w_cm, Crot, (int) (height * 100)); 
	p +=  14;
	}

    *p = '\0';
}

/* -------------------------------------------------------------------------- */
