#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include "/home/cordyn/mk3S/ephemeris.h"
#include "/home/cordyn/mk3S/EWmap.h"


extern int   iCR ;
extern int   east , west , CMmap ;
extern int   numSfiles ;
extern int   leap , Fleap ;
extern long   iFbegEj , iFendEj , iFbegWj , iFendWj ;
extern long   ibegEj , iendEj , ibegWj , iendWj , ibegCj , iendCj ;
extern double  begEj ,  endEj ,  begWj ,  endWj ,  begCj ,  endCj ;
extern char (*filenm)[100] ;
extern int  dispyr , bdoy , edoy , byr , eyr ;
extern int  Fbdoy , Fedoy , Fbyr , Feyr ;

extern int   mon_day() ;
extern int   jday()  ;
extern int   jdate() ;
extern int   iday()  ;


double juld_last , juld_this , juld_next  , juld_future , frac_day ;
int ii , jj ;
int mon , day , yr , doy , last_doy , file_doy , file_yr , flp ;

int nmSYNfiles (Crot) int Crot ; 
{
    int isleap() ;
    extern int Sname() ;
    int not_already_done = 1 ;

    numSfiles = 0 ;


    ii = 0 ;
    if ( Crot < (int) CRtable[0][0] ||  Crot > (int) CRtable[ep_sz-1][0] ) {
	fprintf(stderr,"\
        Rats !  There is no ephemeris entry for your rotation %d.  Hence this\n\
        program doesn't know what SYN___ files to get.  \n\
	Someone will have to update the file \n\
	/home/cordyn/mk3S/ephemeris.h\n\n"
	,Crot  ) ;
	exit(12) ;
    }
      
    while (  Crot > (int) CRtable[ii][0] ) ii++ ;
    if ( Crot != (int) CRtable[ii][0] ) {  
	fprintf(stderr,"\tProblems in indexing Crot %d\n") ;
	exit(13) ; }
    
    iCR = ii ;

    /* Now determine the beginning and ending days of the E and W limb maps. */

    doy = (int) ( CRtable[ii-1][1] ) ; yr = (int) CRtable[ii-1][2] ;
    frac_day =  CRtable[ii-1][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_last = (double)jday ( mon , day , yr ) +frac_day ;  

    doy = (int) ( CRtable[ii][1] ) ; yr = CRtable[ii][2] ;
    frac_day =  CRtable[ii][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_this = (double)jday ( mon , day , yr ) +frac_day ;  

    doy = (int) ( CRtable[ii+1][1] ) ; yr = CRtable[ii+1][2] ;
    frac_day =  CRtable[ii+1][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_next = (double)jday ( mon , day , yr ) + frac_day ;  

    doy = (int) ( CRtable[ii+2][1] ) ; yr = CRtable[ii+2][2] ;
    frac_day =  CRtable[ii+2][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_future = (double)jday ( mon , day , yr ) +frac_day ;  


    begEj = juld_this - ( juld_this - juld_last ) / 4.0 ; ibegEj = (long)begEj ;
    endEj = juld_next - ( juld_next - juld_this ) / 4.0 ; iendEj = (long)endEj ;

    begWj = juld_this + ( juld_next - juld_this ) / 4.0 ; ibegWj = (long)begWj ;
    endWj = juld_next + ( juld_future - juld_next ) / 4.0 ; iendWj =(long)endWj;

    begCj = juld_this ;                                   ibegCj = (long)begCj ;
    endCj = juld_next ;                                   iendCj =(long)endCj;

    iFbegEj = (long) (juld_this + SHIFTE ) ;
    iFendEj = iFbegEj + 33 ;
    iFbegWj = (long) (juld_this + SHIFTW ) ;
    iFendWj = iFbegEj + 33 ;
    if ( east ) {
	jdate ( ibegEj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ;
	jdate ( iendEj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ;

	jdate ( iFbegEj , &mon , &day , &yr ) ;  
	Fbyr = yr ; Fbdoy = iday ( mon , day , yr ) ;
	jdate ( iFendEj , &mon , &day , &yr ) ;  
	Feyr = yr ; Fedoy = iday ( mon , day , yr ) ;
    }
    else if (west) {
	jdate ( ibegWj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ;
	jdate ( iendWj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ;

	jdate ( iFbegWj , &mon , &day , &yr ) ;  
	Fbyr = yr ; Fbdoy = iday ( mon , day , yr ) ;
	jdate ( iFendWj , &mon , &day , &yr ) ;  
	Feyr = yr ; Fedoy = iday ( mon , day , yr ) ;
    }
    else  { /* Must be CMmap */
	jdate ( ibegCj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ;
	jdate ( iendCj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ;

	Fbyr = yr ; Fbdoy = bdoy ;
	Feyr = yr ; Fedoy = edoy ;
    }

    leap = isleap(byr) ;
    if ( byr != eyr )  edoy += 365 + leap ;
    Fleap = isleap(Fbyr) ;
    if ( Fbyr != Feyr )  Fedoy += 365 + Fleap ;

    if      ( Fbyr <   byr )  { file_yr = Fbyr ; flp = Fleap ; 
			        bdoy += 365 + flp ;
			        edoy += 365 + flp ;
		              }
    else if ( Fbyr ==  byr )  { file_yr = Fbyr ; flp = Fleap ; }
    else  /*  Fbyr >   byr */ { file_yr = byr ;  flp = leap  ; 
			        Fbdoy += 365 + flp ;
			        Fedoy += 365 + flp ;
			      }


    doy      = Fbdoy < bdoy ?  Fbdoy : bdoy ;
    last_doy = Fedoy > edoy ?  Fedoy : edoy ;


    /*  Find the filenames.  Each SYN___ file contains 10days, 
        hence the /10 and *10 stuff below. */
    for ( ii=(doy/10)*10 ; ii<=(last_doy/10)*10 ; ii+=10 ) {
	file_doy = ii ;
	if ( file_doy > 365+flp ) { 
	    file_doy -= 365 + flp;  
	    file_doy = (file_doy/10)*10;
	    if ( not_already_done ) { file_yr++ ; not_already_done=0 ; }}
	if ( file_doy == 0 ) file_doy++ ;
	Sname ( file_doy , file_yr , filenm ) ;
	filenm++ ;
	numSfiles++ ;
    }
    return (numSfiles) ;
    
}

int isleap( i_year ) int i_year ; {
    return(  i_year%4 == 0 && i_year%100 != 0 || i_year%400 == 0 )  ;
}

