#include <stdio.h>
#include <ctype.h>
#include "/home/cordyn/mk3S/ephemeris.h"
#include "/home/cordyn/mk3S/EWmap.h"
#include "/home/cordyn/mk3/src/filehd.h"
#include "/home/cordyn/mk3/src/misc.h"

int ch1r0=CH1R0;

extern int   iCR ;
extern int   east , west , CMmap ;
extern int   numSfiles ;
extern int   leap , Fleap ;
extern long   iFbegEj , iFendEj , iFbegWj , iFendWj ;
extern long   ibegEj , iendEj , ibegWj , iendWj , ibegCj , iendCj ;
extern double  begEj ,  endEj ,  begWj ,  endWj ,  begCj ,  endCj ;
extern char (*filenm)[300] , (*filenmba)[300];
extern int  dispyr , bdoy , edoy , byr , eyr ;
extern float flbdoy,fledoy;
extern int  Fbdoy , Fedoy , Fbyr , Feyr ;

extern int doyflag, nameflag, doyflag, dayflag, timeflag, chnme;

extern int   jday()  ;
extern int   jdate() ;
extern int   iday()  ;


double juld_last , juld_this , juld_next  , juld_future , frac_day ;
int mon , day , yr , doy , last_doy , file_doy , file_yr , flp ;

int nmdates (Crot,av,an) int Crot,an; char *av[] ; 
{
    int isleap() ;
    int ii;
    char *w;
    float bfrac,efrac;

    numSfiles = 0 ;


    ii = 0 ;
    if ( Crot < (int) CRtable[0][0] ||  Crot > (int) CRtable[ep_sz-1][0] ) {
	fprintf(stderr,"\
        Rats !  There is no ephemeris entry for your rotation %d.\n\
	Someone will have to update the file \n\
	/home/cordyn/mk3S/ephemeris.h\n\n"
	,Crot  ) ;
	exit(12) ;
    }
      
    while (  Crot > (int) CRtable[ii][0] ) ii++ ;
    if ( Crot != (int) CRtable[ii][0] ) {  
	fprintf(stderr,"\tProblems in indexing Crot %d\n") ;
	exit(13) ; }
    
    iCR = ii ;

    /* Now determine the beginning and ending days of the E and W limb maps. */

    doy = (int) ( CRtable[ii-1][1] ) ; yr = (int) CRtable[ii-1][2] ;
    frac_day =  CRtable[ii-1][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_last = (double)jday ( mon , day , yr ) +frac_day ;  

    doy = (int) ( CRtable[ii][1] ) ; yr = CRtable[ii][2] ;
    frac_day =  CRtable[ii][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_this = (double)jday ( mon , day , yr ) +frac_day ;  

    doy = (int) ( CRtable[ii+1][1] ) ; yr = CRtable[ii+1][2] ;
    frac_day =  CRtable[ii+1][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_next = (double)jday ( mon , day , yr ) + frac_day ;  

    doy = (int) ( CRtable[ii+2][1] ) ; yr = CRtable[ii+2][2] ;
    frac_day =  CRtable[ii+2][1] - (double) doy ;
    mon_day ( doy , yr , &mon, &day );
    juld_future = (double)jday ( mon , day , yr ) +frac_day ;  


    begEj = juld_this - ( juld_this - juld_last ) / 4.0 ; ibegEj = (long)begEj ;
    endEj = juld_next - ( juld_next - juld_this ) / 4.0 ; iendEj = (long)endEj ;

    begWj = juld_this + ( juld_next - juld_this ) / 4.0 ; ibegWj = (long)begWj ;
    endWj = juld_next + ( juld_future - juld_next ) / 4.0 ; iendWj =(long)endWj;

    begCj = juld_this ;                                   ibegCj = (long)begCj ;
    endCj = juld_next ;                                   iendCj =(long)endCj;

    iFbegEj = (long) (juld_this + SHIFTE ) ;
    iFendEj = iFbegEj + 33 ;
    iFbegWj = (long) (juld_this + SHIFTW ) ;
    iFendWj = iFbegEj + 33 ;
    if ( east ) {
	jdate ( ibegEj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ; bfrac=begEj-ibegEj;
	jdate ( iendEj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ; efrac=endEj-iendEj;

	jdate ( iFbegEj , &mon , &day , &yr ) ;  
	Fbyr = yr ; Fbdoy = iday ( mon , day , yr ) ;
	jdate ( iFendEj , &mon , &day , &yr ) ;  
	Feyr = yr ; Fedoy = iday ( mon , day , yr ) ;
    }
    else if (west) {
	jdate ( ibegWj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ; bfrac=begWj-ibegWj;
	jdate ( iendWj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ; efrac=endWj-iendWj;

	jdate ( iFbegWj , &mon , &day , &yr ) ;  
	Fbyr = yr ; Fbdoy = iday ( mon , day , yr ) ;
	jdate ( iFendWj , &mon , &day , &yr ) ;  
	Feyr = yr ; Fedoy = iday ( mon , day , yr ) ;
    }
    else  { /* Must be CMmap */
	jdate ( ibegCj , &mon , &day , &yr ) ;  
	byr = yr ; bdoy = iday ( mon , day , yr ) ; bfrac=begCj-ibegCj;
	jdate ( iendCj , &mon , &day , &yr ) ;  
	eyr = yr ; edoy = iday ( mon , day , yr ) ; efrac=endCj-iendCj;

	Fbyr = yr ; Fbdoy = bdoy ;
	Feyr = yr ; Fedoy = edoy ;
    }

    leap = isleap(byr) ;
    if ( byr != eyr )  edoy += 365 + leap ;
    Fleap = isleap(Fbyr) ;
    if ( Fbyr != Feyr )  Fedoy += 365 + Fleap ;

    if      ( Fbyr <   byr )  { file_yr = Fbyr ; flp = Fleap ; 
			        bdoy += 365 + flp ;
			        edoy += 365 + flp ;
		              }
    else if ( Fbyr ==  byr )  { file_yr = Fbyr ; flp = Fleap ; }
    else  /*  Fbyr >   byr */ { file_yr = byr ;  flp = leap  ; 
			        Fbdoy += 365 + flp ;
			        Fedoy += 365 + flp ;
			      }


    doy      = Fbdoy < bdoy ?  Fbdoy : bdoy ;
    last_doy = Fedoy > edoy ?  Fedoy : edoy ;

    flbdoy=bdoy+bfrac;
    fledoy=edoy+efrac;

    /*  Fill in the files names, checking naming convention. */
    while(--an) {
	sprintf((char *)filenm,"%s",*(++av));
	w=*filenm;   w += (strlen(filenm)-19);
	/* Check on the file naming convention used on the file */
	if ((*w=='0') || (*w >= '8' && *w <= '9')) {
	    if ( *(w+3) >='0' && *(w+3) <='9' )  doyflag++ ;
	    else                                 nameflag++ ;
	}
	if (nameflag || doyflag) { dayflag++ ; timeflag=1; }

	w=*filenm;
	if ( *(w+strlen(filenm)-4) == 'h' ) chnme=1;
	else                                chnme=0;

	filenm++ ;
	numSfiles++ ;
    }
    return (numSfiles) ;
    
}

int isleap( i_year ) int i_year ; {
    return(  i_year%4 == 0 && i_year%100 != 0 || i_year%400 == 0 )  ;
}

int
fillsyarry(sbuf,pBim,fba,nn,diode)
    short *sbuf, *pBim;
    float *fba;
    int nn,diode;
{
    float *pfba;
    double tstang, PosA, fabs();
    short *sy;
    int ii, jj;


    pfba=fba;
    sy=sbuf;
    for(ii=0;ii<360;ii++){
	PosA = (double)ii;
	pfba=fba;
	for(jj=0;jj<nn;jj++){
	    tstang= (double)(*pfba) - PosA; pfba++;
	    if( fabs(tstang) < 0.5 ) {
		*(sy+ii) = *(pBim +jj*128 +diode);
		break;
	    }
	}
    }
}
static int day_tab[2][13] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,                              0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
			    } ;
int mon_day(doy, year , pmon , pday ) int doy , year , *pmon , *pday ;
{
    int ii , leap ;

    leap = year%4 == 0 && year%100 != 0 || year%400 == 0 ;

    for ( ii=1 ; doy > day_tab[leap][ii]  ; ii++ )
	doy -= day_tab[leap][ii] ;
    *pmon = ii ;
    *pday = doy ;
    return(0) ;
}
