#include <stdio.h>
#include <ctype.h>
/* #include <sys/types.h> */
#include "/home/cordyn/mk3/misc.h"
#include "/home/cordyn/mk3S/EWmap.h"



extern double ba2rad ;
extern double rtd ;  /* Both in misc.c */

char filenm[100], longname[255], picnm[80], *piceos, ffilenm[100] ;
char bbuf[100000] ;
extern char *malloc(), *rindex();

typedef unsigned char u_char;
short *pB;
short *bangles , *ba ;
double dtmp ;
u_char *sy ;
long ui , reclen , file_size , file_pos , im_spot , a_spot , sv_spot , ck_spot ;
int dayflag, timeflag, chanflag;
int idflag , udflag , qdflag , pBflag , posflag , negflag ;
int aflag , s16flag , s8flag , baflag , rs8flag ;
int imgcnt ;
int doyflag ;

float      r0 =  1.1224     ;        /* 12/12/90 test value */
float      dr =  0.0104244  ;        /* 12/12/90 test value */

float sn=RSMIN , sx=RSMAX ;
 


main (an, av) char *av[]; {
    register long ii, jj ;
    register char *w;
    register FILE *ofid , *ifid;
    register LS list = &listhd;
    register SFH syfilhd = &listhd.head;
    int kk ;

    file_pos = 0 ;
    dayflag=timeflag=chanflag= 0;
    aflag=s16flag=s8flag=baflag=rs8flag= 0 ;
    if ( an <= 1 ) { exit(3) ; }
    while (--an) {
	if (*(w = *++av) == '-')	/* Check for flag arguments */
	    switch (w[1]) {
	    case 'a':  aflag++; break;  /* ascii */
	    case 'b':  baflag++; break;  /* Get bangles- print out as ascii. */
	    case '1':  s16flag++; break; /* Get the synoptic data as shorts */
	    case '8':  s8flag++; break; /* Scale the synoptic data to bytes. */
	    case 'r':  s8flag++; 
		       rs8flag++; /* Use the standard rescale for syn
		                     images.  -100 to 2900  to bytes. */
		       break ;
	    case 'd':  doyflag++ ; break; /* Force using doy name. */
	    default:   fprintf (stderr," unknown flag %s\n",*av);
		       exit(1);
	    }

	else {			/* Get the synoptic filename. */

	    if (*w == '?') { exit(2); }

	    strcpy( filenm , w ) ; 
	    sprintf(ffilenm,"%s.fix",filenm);

	}
    }
    fprintf (stderr,"Opening --> %s\n",filenm);
    printf ("%s\n",filenm);                     /* Open the synoptic file. */

    if ( (ifid=fopen (filenm,"r")) == NULL) {
	fprintf(stderr,"%s does not exist...\n",filenm);
	exit (1);
    }
    if ( (ofid=fopen (ffilenm,"w")) == NULL) {
	fprintf(stderr,"%s can\'t be opened for writing...\n",ffilenm);
	exit (1);
    }


    fseek ( ifid, 0 , 2 ) ;
    file_size = ftell(ifid) ;  
    rewind(ifid) ;


    for (imgcnt=0;;imgcnt++) {	/* Begin the loop to fill the lst 
		   structure for each of the images. */

	a_spot = ftell(ifid) ;  

	/*  Read in the record (image) length, checking that 
	    we're not at the end of the synoptic file. */
	jj = fread (&ui,4,1,ifid); 
	reclen = ui ;
	if ( ui > 0 ) {
	    printf ("Image #%d.\n",imgcnt+1) ;
	    printf ("    Record length -->  %ld \n",ui) ;
	}
	if (jj <= 0 ) { 
	    printf("\nNo more data in the file.\n"); 
	    break; }
	if (ui == 0 ) { 
	    printf("\nNo more data in the file.\n"); break; }
	if ( ui < 0 ) { 
	    if ( ui != -2147450880 ) {
		printf("\nreclen is ui=%x, %ld indicating corruption.\n",ui,ui);
		fprintf(stderr,"There is some corruption in the file.\n") ;
	    }
	}
	if ( feof(ifid))   { printf("\nEOF was found.\n") ; break; }
	if ( ferror(ifid)) { printf("\nferror on ifid was found.\n"); break; }

	fread (&ui,4,1,ifid); 
	sv_spot = ftell(ifid) ;  
	printf ("    Record offset -->  %d \n",ui) ;
	if ( ui != HDR ) {
	    fprintf(stderr,"\n\tSomething is wrong with the image number %d.\n",
		imgcnt+1);
	    fprintf(stderr,"\n\tTrying to backtrack and fix...\n");
	    fseek(ifid,a_spot-(long)(50*8),0) ; 
	    fread (&ui,4,1,ifid);  
	    while ( ui != HDR ) {
		fread (&ui,4,1,ifid); 
		if ( (ck_spot=ftell(ifid)) > file_size-(long)(HDR)) {
		    fprintf(stderr,"Can\'t find the messed up file!\n");
		    exit(-33);
		}
	    }
	    fseek(ifid,ck_spot-(long)(8),0) ; 
	    im_spot = ck_spot - (long)(8) ;
	    im_spot = ftell(ifid);
	    jj = fread (&ui,4,1,ifid); 
	    printf ("\t\tRecord length -->  %ld \n",ui) ;
	    reclen = ui ;
	    fread (&ui,4,1,ifid); 
	    sv_spot = ftell(ifid) ;  
	    printf ("\t\tRecord offset -->  %ld \n",ui) ;
	}
	else {
	    im_spot=a_spot ;
	}
	printf ("\t\tImage location is -->  %ld \n",im_spot) ;
	printf ("\t\tSaved location is -->  %ld \n",sv_spot) ;
	fseek(ifid,im_spot,0) ; 
	fread(bbuf,reclen,1,ifid); fwrite(bbuf,reclen,1,ofid);
	fseek(ifid,sv_spot,0) ; 








	fseek (ifid,256,1);    /* Skip the next 256 bytes. This contains 
				   the ascii header. */


	if (list->syoff != 0) {  /* The second and subsequent time through,
			     allocate space the new image's lst structure. */
	    list->next = (LS) malloc (sizeof (struct lst));

	    list = list->next;   /* The previous image's list is set to the 
				address of the structure for this image. */
	    syfilhd = &(list->head);  /* Set the address of syfilhd for this 
					image. */
	}
	/* The first time, list->syoff==0, and memory for lst was allocated 
	   in the delclaration for listhd. */


	/* Fill up the syfilhd structure. */
	if ((jj = fread (syfilhd,1,sizeof (struct syfilhd),ifid))
	    != sizeof (struct syfilhd)) {
		printf(stderr,"\nThe header for image %d cannot be read !\n",
		imgcnt+1 ) ;
		exit (4);
	}


	printf ("    %s %s chan = %d  flags %s\n\n",/* Print out date, time */
	    prday(syfilhd->juld), prtime(syfilhd->time),
	    syfilhd->chan, prflags(syfilhd->flags));

	/* Skip past the image data, we'll get it if we need it, later. */
	fseek (ifid,reclen-HDR-sizeof(struct syfilhd),1);


	/* See if we are near the end of the file. */
	if ( ii >= file_size-(reclen/2) )  break ;

    }

    list->next = 0 ;

    exit (0);


}
