#include <stdio.h>
#include <ctype.h>
/* #include <sys/types.h> */
#include "/home/cordyn/mk3/src/misc.h"
#include "/home/cordyn/mk3S/EWmap.h"



extern double ba2rad ;
extern double rtd ;  /* Both in misc.c */

char filenm[100], longname[255], picnm[80], *piceos;
extern char *malloc(), *rindex();

typedef unsigned char u_char;
short *pB;
short *bangles , *ba ;
double dtmp ;
u_char *sy ;
long ui , reclen , file_size , file_pos ;
int dayflag, timeflag, chanflag;
int idflag , udflag , qdflag , pBflag , posflag , negflag ;
int aflag , s16flag , s8flag , baflag , rs8flag ;
int day,cal0flag,quickflag,cal15flag,year,mon,Neflag;
int imgcnt ;
int doyflag ;

float      r0 =  1.1224     ;        /* 12/12/90 test value */
float      dr =  0.0104244  ;        /* 12/12/90 test value */

float sn=RSMIN , sx=RSMAX ;
 


main (an, av) char *av[]; {
    register long ii, jj ;
    register char *w;
    register FILE *ofid , *ifid;
    register LS list = &listhd;
    register SFH syfilhd = &listhd.head;
    int kk ;

    file_pos = 0 ;
    dayflag=timeflag=chanflag= 0;
    aflag=s16flag=s8flag=baflag=rs8flag= 0 ;
    if ( an <= 1 ) { prsum() ; exit(3) ; }
    while (--an) {
	if (*(w = *++av) == '-')	/* Check for flag arguments */
	    switch (w[1]) {
	    case 'a':  aflag++; break;  /* ascii */
	    case 'b':  baflag++; break;  /* Get bangles- print out as ascii. */
	    case '1':  s16flag++; break; /* Get the synoptic data as shorts */
	    case '8':  s8flag++; break; /* Scale the synoptic data to bytes. */
	    case 'r':  s8flag++; 
		       rs8flag++; /* Use the standard rescale for syn
		                     images.  -100 to 2900  to bytes. */
		       break ;
	    case 'd':  doyflag++ ; break; /* Force using doy name. */
	    default:   fprintf (stderr," unknown flag %s\n",*av);
		       prsum(); exit(1);
	    }

	else {			/* Get the synoptic filename. */

	    if (*w == '?') { prsum(); exit(2); }

	    strcpy( filenm , w ) ; 


	}
    }
    fprintf (stderr,"Opening --> %s\n",filenm);
    printf ("%s\n",filenm);                     /* Open the synoptic file. */

    if ( (ifid=fopen (filenm,"r")) == NULL) {
	fprintf(stderr,"%s does not exist locally.\n Trying on puu..\n",filenm);
	sprintf(longname,"/puu/d/cordyn/Synoptc/%s",filenm) ;
	fprintf(stderr,"Opening--> %s\n",longname) ;
	if (( ifid=fopen (longname,"r") ) == NULL) {
	    fprintf (stderr,"\n\007 %s does not exist either.\n",longname);
	    exit (1);
	}
    }


    if ( aflag + baflag + s16flag + s8flag == 0) {
	fprintf (stderr,"\nSince you have not specified a data type,\n") ;
	fprintf (stderr,"     such as, -a , -b , -pB, or -s \n");
	fprintf (stderr,"     no data files will be created!\n");
	fprintf (stderr,"     Only summary information will be printed.\n\n");
	fprintf (stderr,
	"     Standard usage is: sy_get [-a] [-b] [-pB] [-s] [file]\n\n");
    }


    fseek ( ifid, 0 , 2 ) ;
    file_size = ftell(ifid) ;  
    rewind(ifid) ;


    for (imgcnt=0;;imgcnt++) {	/* Begin the loop to fill the lst 
		   structure for each of the images. */

	/*  Read in the record (image) length, checking that 
	    we're not at the end of the synoptic file. */
	jj = fread (&ui,4,1,ifid); 
	reclen = ui ;
	if ( ui > 0 ) {
	    printf ("Image #%d.\n",imgcnt+1) ;
	    printf ("    Record length -->  %ld \n",ui) ;
	}
	if (jj <= 0 ) { 
	    printf("\nNo more data in the file.\n"); 
	    break; }
	if (ui == 0 ) { 
	    printf("\nNo more data in the file.\n"); break; }
	if ( ui < 0 ) { 
	    if ( ui != -2147450880 ) {
		printf( "\nui=%x , %ld indicating corruption.\n",ui,ui);
		printf( "\nIt appears that the rest of the file is garbage.\n");
		printf( "The first %d images will be recovered...\n",imgcnt);
		fprintf(stderr,"There is some corruption in the file.\n") ;
		fprintf(stderr,"The first %d images will be recovered.\n",
				imgcnt);
	    }
	    break;
	}
	if ( feof(ifid))   { printf("\nEOF was found.\n") ; break; }
	if ( ferror(ifid)) { printf("\nferror on ifid was found.\n"); break; }

	fread (&ui,4,1,ifid); 
	printf ("    Record offset -->  %d \n",ui) ;
	if ( ui != HDR ) {
	    fprintf(stderr,"\nSomething is wrong with the image number %d.\n\
	    The first %d images will be recovered...\n",imgcnt+1,imgcnt);
	    break ;
	}
	fseek (ifid,256,1);    /* Skip the next 256 bytes. This contains 
				   the ascii header. */


	if (list->syoff != 0) {  /* The second and subsequent time through,
			     allocate space the new image's lst structure. */
	    list->next = (LS) malloc (sizeof (struct lst));

	    list = list->next;   /* The previous image's list is set to the 
				address of the structure for this image. */
	    syfilhd = &(list->head);  /* Set the address of syfilhd for this 
					image. */
	}
	/* The first time, list->syoff==0, and memory for lst was allocated 
	   in the delclaration for listhd. */


	/* Fill up the syfilhd structure. */
	if ((jj = fread (syfilhd,1,sizeof (struct syfilhd),ifid))
	    != sizeof (struct syfilhd)) {
		fprintf(stderr,"\nThe header for image %d cannot be read !\n",
		imgcnt+1 ) ;
		exit (4);
	}


	printf ("    %s %s chan = %d  flags %s\n",/* Print out the sumry info */
	    prday(syfilhd->juld), prtime(syfilhd->time),
	    syfilhd->chan, prflags(syfilhd->flags));

	if ( idflag ) 		printf("    This image is I data.\n") ;
	else if ( udflag ) 	printf("    This image is U data.\n") ;
	else if ( pBflag ) 	printf("    This image is pB data.\n") ;
	else 			printf("    This image is Q data.\n") ;

	if ( posflag ) 	printf("    The scan direction is CCW, positive.\n") ;
	else if ( negflag ) 	
			printf("    The scan direction is  CW, negative.\n") ;
	else 		printf("    The scan direction unknown.\n") ;


	/*  Determine and fill up the rest of the lst structure. */
	ii = syfilhd->nray;
	list->baoff = ftell(ifid);
	list->syoff = list->baoff + (jj = ((ii + 3) & ~3) * 2);


	/* Skip past the image data, we'll get it if we need it, later. */
	fseek (ifid,reclen-HDR-sizeof(struct syfilhd),1);


	/* Print out the rest of the sumry info. */
	printf ("    nray = %d  bsize = %d\n",  ii, jj);
	printf ("    phase = %d %7.3f\n",       syfilhd->phase, 
						phi(syfilhd->phase)*rtd);
	printf ("    bright = %d\n",            syfilhd->bright);
	printf ("    pangle = %d %7.3f\n",      syfilhd->pangle,
					        pangle(syfilhd->pangle)*rtd);
	printf ("    pBmin = %d  pBmax = %d\n", syfilhd->qmin,syfilhd->qmax);
	printf ("    didxn = %d  didxx = %d\n", syfilhd->didxn,syfilhd->didxx);

	if ( rs8flag ) printf(
	    "    Scaling information: %.1f to %.1f will be  0 to 255\n\n"
	    ,sn,sx);
	if ( s8flag  && !rs8flag ) printf(
	    "    Scaling information: %d to %d will be  0 to 255\n\n",
	    syfilhd->qmin,syfilhd->qmax);



	/* Make sure we are where we think we are. */
	ii = ftell(ifid) ;
	file_pos += reclen ;
	if ( ii != file_pos ) fprintf(stderr,
	    " Position %ld file_pos %ld reclen %ld \n",ii,file_pos,reclen) ;

	/* See if we are near the end of the file. */
	if ( ii >= file_size-(reclen/2) )  break ;

    }
    list->next = 0 ;



    if ( s8flag + s16flag + aflag + baflag == 0) exit (0);


    /* Determine the name template for the individual image files. */
    list = &listhd;
    ii = list->head.juld;
    for (; list ; list = list->next ) {
	if ((jj = list->head.juld) != ii) dayflag++;
	else timeflag++;
	chanflag |= (1 << list->head.chan);
	ii = jj;
    }
    if ( doyflag ) { dayflag++ ; timeflag = 1 ; }

    switch (chanflag) {
	case 1:    chanflag = 0; break ;
	case 2:    chanflag = 1; break ;
	case 4:    chanflag = 2; break ;
    }
    printf ("\n%s%s%s\n\n",
	dayflag ? "dayflag " : "",
	timeflag ? "timeflag " : "",
	chanflag ? "chanflag " : "");



    /* Get some storage for the input image. */
    pB = (short *)malloc (SYSIZE*DIODES);

    /* Get some storage for output data. */
    if (s8flag)  sy = (unsigned char *)malloc (SYITEMS*DIODES);

    if (baflag) bangles = (short *)malloc (BANGLES*sizeof(short) ) ;


    imgcnt=1;
    /*  Get the image types desired. */
    for (list = &listhd ; list ; list = list->next ) {
	dopicnm (&list->head); 		/* Fill up the rest of the name. */
	/* sprintf(picnm,"%s%02d.",picnm,imgcnt);  imgcnt++; piceos+=3;  */
	printf ("Name %s\n",picnm);

	if (s16flag || s8flag || aflag ) {

	    fseek (ifid,list->syoff,0); 
	    fread (pB,2,SYITEMS*DIODES,ifid);
	    if(aflag) {
		dofnm(1) ;
		if( (ofid = fopen(picnm,"w"))==NULL ) {
		    fprintf(stderr,
		    "\tCan\'t open %s. Exitting\n",picnm); exit(-4); }
		do_ascii(pB,ofid) ;
		if ( fclose(ofid) )
		    fprintf(stderr,"\t\tHaving trouble closing %s\n",picnm);
	    }
	    if (s8flag) {
		dofnm(2) ;
		if( (ofid = fopen(picnm,"w"))==NULL ) {
		    fprintf(stderr,
		    "\tCan\'t open %s. Exitting\n",picnm); exit(-4); }
                do_char(pB,SYITEMS*DIODES,list->head.qmin,list->head.qmax,sy);
		fwrite(sy,1,SYITEMS*DIODES,ofid); 
		if ( fclose(ofid) )
		    fprintf(stderr,"\t\tHaving trouble closing %s\n",picnm);
	    }
	    if (s16flag) {
		dofnm (3); 
		if( (ofid = fopen(picnm,"w"))==NULL ) {
		    fprintf(stderr,
		    "\tCan\'t open %s. Exitting\n",picnm); exit(-4); }
		fwrite(pB,2,SYITEMS*DIODES,ofid); 
		if ( fclose(ofid) )
		    fprintf(stderr,"\t\tHaving trouble closing %s\n",picnm);
	    }
	}
	if (baflag) {
	    dofnm (0); 
	    if( (ofid = fopen(picnm,"w"))==NULL ) {
		fprintf(stderr,"\tCan\'t open %s. Exitting\n",picnm); exit(-4);}
	    fprintf(ofid,"The bangles:\n");

	    fseek (ifid,list->baoff,0);
	    fread (bangles,2,list->head.nray,ifid);

	    for ( ba=bangles, kk=1;  kk<=(int)list->head.nray;  kk++, ba++ ) { 
		dtmp = (double) ( ba2rad*rtd*( (double)*ba ) ) ;
		fprintf(ofid,"%6.2lf ",dtmp ) ;
		if( 10*(kk/10) == kk ) fprintf(ofid,"\n") ;
	    }
	    fprintf(ofid,"\n");
	    if ( fclose(ofid) )
		fprintf(stderr,"\t\tHaving trouble closing %s\n",picnm);
	}
    }

    fclose(ifid) ;

    exit (0);


}



dofnm (which) int which; {
    register char *p = piceos;

    switch (which) {
    case 0:	/* b-angles */
	    *p++ = 'b';    *p++ = 'a';    break;

    case 1: /* pB in ascii format pBsyn.a */
	    *p++ = 'p';   
	    *p++ = 'B';    
	    *p++ = 's';    
	    *p++ = 'y';   
	    *p++ = 'n';
	    *p++ = '.';
	    *p++ = 'a';
	    break ;

    case 2:     /* syn --> scaled, 8-bit synoptic pB data. */
	    *p++ = 's';    
	    *p++ = 'y';   
	    *p++ = 'n';
	    break ;

    case 3:	/* pBsyn --> 16-bit synoptic pB data. */
	    *p++ = 'p';   
	    *p++ = 'B';    
	    *p++ = 's';    
	    *p++ = 'y';   
	    *p++ = 'n';
	    break;
    }
    *p = '\0';
}


dopicnm (syfilhd) register SFH syfilhd; {
    register char *p = picnm;
    static char months[] = "janfebmaraprmayjunjulaugsepoctnovdec";
    int mon, day, year , doy ;
    extern int get_doy() ;

    if (dayflag) {
	jdate (syfilhd->juld + 2415021, &mon, &day, &year);
	if (!doyflag) {
	    sprintf (p,"%2d%3.3s%02d.",year-1900,months+(mon-1)*3,day);
	    p += 8; 
	}
	else {
	    doy = get_doy (mon, day, year);
	    sprintf (p,"%2dd%03d.",year-1900,doy);
	    p += 7; 
	}
    }

    if (timeflag) {
	sprintf (p,"%5.5s.", prtime(syfilhd->time));
	p += 6; }
    if (chanflag) {
	    *p++ = 'c'; *p++ = 'h'; *p++ = syfilhd->chan + '0'; *p++ = '.'; }

    *p = '\0';
    piceos = p;
}


do_char (PB, i, n, x, q)
    short *PB;
    register int i, n, x;
    register u_char *q; {  register short *p ;    p = PB ;

    if ( rs8flag )  {  x = RSMAX ;  n = RSMIN ;   }
    for (; --i >= 0 ; p++, q++)
	if (*p == -32768) *q = 0;
	else {
	    *p =  ( *p < x  )  ?  *p : x ;
	    *p =  ( *p > n  )  ?  *p : n ;
	    if ( (x-n) != 0 ) *q = ((*p - n) * 255) / ( x - n ) ;
	    else *q = 250 ;
	}
}

do_ascii(pBsyn,fid) short *pBsyn ;  FILE *fid ;     {
    int jj , kk ;
    int datmin , datmax ;
    short *tmpp ;

    fprintf(fid,"Synoptic data, from 0-359 degrees in 1 degree increments.\n");
    fprintf(fid,"This is pB data (*10+10B/Bsun) which has NOT been multiplied\n\
    by the 1.04 WLCC correction factor NOR the El Chicon correction factor.\n\n"
    ) ;

    tmpp = pBsyn ;
    for (jj=0 ; jj<DIODES ; jj++ ) {
	datmin = 1000 ; datmax = -1000 ;
	for (kk=1 ; kk <= SYITEMS ; kk++ ) {
	    fprintf(fid," %5d ",*tmpp ) ;
	    if ( *tmpp > datmax )  datmax = *tmpp ;
	    if ( *tmpp < datmin )  datmin = *tmpp ;
	    tmpp++ ;
	    if( 10*(kk/10) == kk ) fprintf(fid,"\n") ;
	}
	fprintf(fid,"\nThe above data is from diode %d,  Rsun %.3f ",
		     jj,(float)(r0 + jj*dr) ) ;
	fprintf(fid,"\nMin data value: %d "   ,datmin ) ;
	fprintf(fid,"\nMax data value: %d\n\n",datmax ) ;
    }
}

prsum() {
    static char help[] = "\
\n\
sy_get [-a] [-b] [-16] [-8] [-rs8] [-d] [file]\n\
\n\
Example:              sy_get -16 SYNC01 >> sumry1-91 \n\
Example:              sy_get -8  SYNC01 >> sumry1-91 \n\
\n\
Flags	    Description\n\
-----       ------------\n\
-[a]        puts out the synoptic data as ascii             --> ____.pBsyn.a \n\
\n\
-[b]        puts out the Barrel angles as ascii             --> ____.ba \n\
\n\
-[16]       gets the synoptic pB data and puts it in a 16-bit \n\
	        integer array, pB[128][360]                 --> ____.pBsyn \n\
-[8]        gets the synoptic pB data and puts it in an 8-bit \n\
		integer array, pB[128][360]                 --> ____.syn\n\
-[rs8]      uses a constant scaling of 100 to 3000 mapping to 0-255 \n\
		for the 8-bit data above. \n\
-[d]    Forces a long DOY filename e.g. 88d304.18_34.syn \n\
";

       fputs (help,stderr);
}
