#include <stdio.h>
#include "/home/cordyn/mk3S/EWmap.h"


/* For both Bmap and BCmap, (imap and cmap) 
       longitude goes from 0 to 360 degrees, 
       with 0 degrees on the left and 360 degrees on the right.
       Time is reversed, so that the earliest day is on the right,
       and the latest day is on the left.
   In idl, cmap can be displayed with: a=intary(360,360)
					tvscl,a,order=1
   In idl, imap can be displayed with: a=intary(360,181)
					tvscl,a,order=1
*/
extern float INTERPDAY;


extern int  offset ;

terpimap (Long,numlong,smlmap,bigmap,numjj) 
    float Long[] ;
    int numlong , numjj ;  
    short *smlmap , *bigmap ;  
{
    register int ii , jj ,  nl ;
    register int   long_hi , long_lo ;
    register int   indx_hi , indx_lo ;
    float deltaL ;
    int   ideltaL ;
    float slope ;

    fprintf(stderr,"\n\tSmoothing between points in the map.\n");
    for (nl=1 ; nl < numlong ; nl++ ) {
	long_hi = (int)Long[nl-1] ;
	long_lo = (int)Long[nl] ;	 

	indx_hi = long_hi +offset ;
	indx_lo = long_lo +offset ;

	deltaL = long_hi - long_lo ;
	ideltaL = (int) deltaL ;

	for( jj=0; jj < numjj ; jj++ ){ /* Fill the day with itself. */
	    for(ii=(-DAYDEGR*0.5) ; ii<=(DAYDEGR*0.5) ; ii++ ) {
		if(((int)long_lo+ii>=0) && ((int)long_lo+ii < LONGS ) )
		    *(smlmap+jj*LONGS+(int)long_lo+ii) = 
				     *(bigmap+jj*BLONGS+indx_lo) ;
	    }
	}

	/* Interpolate if it is possible. */
	if ( ideltaL && ideltaL < INTERPDAY*DAYDEGR ) {
	    for( jj=0; jj < numjj ; jj++ ){
		slope = (float)(*(bigmap+jj*BLONGS+indx_hi) 
			      - *(bigmap+jj*BLONGS+indx_lo))
			/ deltaL ;
		for(ii=0 ; ii<=ideltaL ; ii++ ) {
		    if(((int)long_lo+ii>=0) && ((int)long_lo+ii < LONGS ) )
			*(smlmap+jj*LONGS+(int)long_lo+ii) = 
			    (slope*ii) + *(bigmap+jj*BLONGS+indx_lo) ;
		}
	    }
	}
    }
}
